# randrot.pl
# save this code to file: "unnomify_water_barrel.pl"
# run with command line:
# tes3cmd modify --program-file unnomify_water_barrel.pl myplugin.esp

use strict;

sub main {
   my($tr) = @_; # tr = the record
   my $ok = 0;
   my $x_angle = 0;
   my $y_angle = 0;
   my $q = 0;
   my $subtype = '';
   my $name = '';
   my $ok2 = 0;
   my $tsr_last = '';
   if ($tr->rectype eq 'CELL') { # only interested in CELL records
      $ok = 0;
      foreach my $tsr (@{$tr->{SL}}) { # tsr = the sub-record
         $subtype = $tsr->subtype;
         if ( $ok == 0 ) {
            if ($subtype eq 'FRMR') { 
               $ok = 1; 
            }
         }
         elsif ( $ok == 1 ) {
            if ( ($subtype eq 'NAME') && ($tsr->{name} =~ m/NOM_water_barrel/i) )  {
               #found id containing "NOM_water_barrel"
               $name = $tsr->{name};
               $tsr_last = $tsr;
               $ok = 2;
            }
            else {
               $ok = 0;
            }
         }
         elsif ( $ok == 2 ) {
            if ($subtype eq 'DATA') {
               $x_angle = $tsr->{x_angle};
               $x_angle = $x_angle * 57.2957795; # convert from radians to degrees
               $q = int($x_angle/360);
               if ( $q > 0 ) {
                  $x_angle -= $q*360;
               }
               elsif ( $q < 0 ) {
                  $x_angle += $q*360;
               }
               if ($x_angle > 10) {
                  $ok2 = 1;
               }
               elsif ($x_angle < -10) {
                  $ok2 = 1;
               }
               else {
                  $ok2 = 0;
               }
               $y_angle = $tsr->{y_angle};
               $y_angle = $y_angle * 57.2957795; # convert from radians to degrees
               if ( $ok2 == 0 ) {
                  $q = int($y_angle/360);
                  if ( $q > 0 ) {
                     $y_angle -= $q*360;
                  }
                  elsif ( $q < 0 ) {
                     $y_angle += $q*360;
                  }
                  if ($y_angle > 10) {
                     $ok2 = 1;
                  }
                  elsif ($y_angle < -10) {
                     $ok2 = 1;
                  }
                  else {
                     $ok2 = 0;
                  }
               }
               if ( $ok2 ) {
                  $tsr_last->{name}='barrel_01_empty';
                  $tr->{_modified_} = 1; # tell tes3cmd we modified the record
                  print "\r\n $name --> ".$tsr_last->{name}."  x_angle=$x_angle, y_angle=$y_angle\r\n";
               }
               $ok = 0;
            }
         }
      }
   }
}